/*
 * HtmlPainter.h
 *
 *  Created on: 30.7.2010
 *      Author: sber
 */

#ifndef HTMLPAINTER_H_
#define HTMLPAINTER_H_

#include <QLabel>
#include <QString>
#include <QScopedPointer>

class HtmlPainter
    {
public:
    enum Type {
        Title,
        Content,
        Info,
        Detail
    };
    
    HtmlPainter(Type type, bool oneLineMode);
    virtual ~HtmlPainter();
    
    void setContent(QString const & content);
    QSize setWidthAndMode(int width, bool oneLine);
    void paint(QPainter * painter, QRectF const & rect);
    
    QFontMetrics const fontMetrics() { return label->fontMetrics(); }
    
private:
    
    void renderInRect(QWidget * widget, QPainter * painter, QRectF const & rect);
    
    bool oneLineMode;
    int ellipsisWidth;
    
    bool showEllipsis;
    
    int previousWidth;
    QSize previousSize;
    
    QScopedPointer<QLabel> label;
    QScopedPointer<QLabel> ellipsisLabel;
    };

#endif /* HTMLPAINTER_H_ */
