#ifndef IMAGESEARCHTHREAD_H
#define IMAGESEARCHTHREAD_H

#include <QThread>
#include <QLinkedList>

class QDir;
class QFileInfo;

class ImageSearchThread : public QThread
{
    Q_OBJECT

public:
    ImageSearchThread(QObject* parent = 0);
    ~ImageSearchThread();

public:
    void run();
    void Cancel();
    inline bool IsCanceled() { return iThreadCancelled; }

    typedef QLinkedList<QFileInfo const> FileInfoList;
    FileInfoList const & InfoList() { return iFileInfos; }

private:
    void ParseDir(const QDir& aDir);

private:
    volatile bool iThreadCancelled;
    FileInfoList iFileInfos;
};

#endif // IMAGESEARCHTHREAD_H
