#ifndef LOCATIONBUTTON_H_
#define LOCATIONBUTTON_H_

#include <QPushButton>
#include <QGeoCoordinate>

class QResizeEvent;

class LocationButton : public QPushButton
    {
    Q_OBJECT
    
public:
    LocationButton(QWidget * parent = 0);
    
    void resetCoordinate();
    void setCoordinate(QtMobility::QGeoCoordinate const & newCoordinate);
    
protected:
    // make protected
    void setText(const QString & str) { QPushButton::setText(str); } 
    
    // override
    void resizeEvent(QResizeEvent* event);
    
private:
    void updateText();
    int getTextWidth();
    
private:
    
    QtMobility::QGeoCoordinate coordinate;
    };

#endif /* LOCATIONBUTTON_H_ */
